using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DesignAll
{
	/// <summary>
	/// UserDataForm ժҪ˵
	/// </summary>
	public class UserDataForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Button btnInsert;
		private System.Windows.Forms.Button btnEdit;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.ListView listUserData;
		/// <summary>
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserDataForm()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			System.Windows.Forms.ListViewItem listViewItem1 = new System.Windows.Forms.ListViewItem(new string[] {
																													 "Name",
																													 "June Shi"}, -1);
			this.listUserData = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnInsert = new System.Windows.Forms.Button();
			this.btnEdit = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.btnDelete = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// listUserData
			// 
			this.listUserData.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.columnHeader1,
																						   this.columnHeader2});
			this.listUserData.Items.AddRange(new System.Windows.Forms.ListViewItem[] {
																						 listViewItem1});
			this.listUserData.Location = new System.Drawing.Point(8, 8);
			this.listUserData.MultiSelect = false;
			this.listUserData.Name = "listUserData";
			this.listUserData.Size = new System.Drawing.Size(232, 312);
			this.listUserData.TabIndex = 0;
			this.listUserData.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Key";
			this.columnHeader1.Width = 111;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Value";
			this.columnHeader2.Width = 108;
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(256, 24);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 1;
			this.btnAdd.Text = "&Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnInsert
			// 
			this.btnInsert.Location = new System.Drawing.Point(256, 56);
			this.btnInsert.Name = "btnInsert";
			this.btnInsert.TabIndex = 2;
			this.btnInsert.Text = "&Insert";
			this.btnInsert.Click += new System.EventHandler(this.btnInsert_Click);
			// 
			// btnEdit
			// 
			this.btnEdit.Location = new System.Drawing.Point(256, 88);
			this.btnEdit.Name = "btnEdit";
			this.btnEdit.TabIndex = 3;
			this.btnEdit.Text = "&Edit";
			this.btnEdit.Click += new System.EventHandler(this.btnEdit_Click);
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(256, 296);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 4;
			this.btnClose.Text = "&Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// btnDelete
			// 
			this.btnDelete.Location = new System.Drawing.Point(256, 120);
			this.btnDelete.Name = "btnDelete";
			this.btnDelete.TabIndex = 5;
			this.btnDelete.Text = "&Delete";
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			// 
			// UserDataForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(346, 338);
			this.Controls.Add(this.btnDelete);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.btnEdit);
			this.Controls.Add(this.btnInsert);
			this.Controls.Add(this.btnAdd);
			this.Controls.Add(this.listUserData);
			this.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "UserDataForm";
			this.Text = "UserData Editor";
			this.Load += new System.EventHandler(this.UserDataForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		public MainForm mainForm;

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void UserDataForm_Load(object sender, System.EventArgs e)
		{
			listUserData.Items.Clear();
			for (Int32 i=0;i<mainForm.myCAD1.GetSelectedShape().UserData.UserDataRecord.Length;++i)
			{
				ListViewItem lvi = new ListViewItem(mainForm.myCAD1.GetSelectedShape().UserData.UserDataRecord[i].Key);
				lvi.SubItems.Add(mainForm.myCAD1.GetSelectedShape().UserData.UserDataRecord[i].Value);
				listUserData.Items.Add(lvi);
			}
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			//mainForm.myCAD1.GetSelectedShape().UserData.AddKeyAndValue("Name","June");
			UserDataEditForm userdataEditForm = new UserDataEditForm();
			userdataEditForm.ShowDialog();
			if (userdataEditForm.DialogResult == DialogResult.OK)
			{
				mainForm.myCAD1.GetSelectedShape().UserData.AddKeyAndValue(userdataEditForm.textKey.Text,userdataEditForm.textValue.Text);
			}
			userdataEditForm.Dispose();
			
			//Reload
			UserDataForm_Load(sender,e);
		}

		private void btnEdit_Click(object sender, System.EventArgs e)
		{
			foreach (ListViewItem lvi in listUserData.SelectedItems)
			{
				UserDataEditForm userdataEditForm = new UserDataEditForm();
				userdataEditForm.textKey.Text = lvi.Text;
				userdataEditForm.textValue.Text = mainForm.myCAD1.GetSelectedShape().UserData.GetValueByKey(lvi.Text);
				userdataEditForm.ShowDialog();
				if (userdataEditForm.DialogResult == DialogResult.OK)
				{
					mainForm.myCAD1.GetSelectedShape().UserData.UserDataRecord[lvi.Index].Key = userdataEditForm.textKey.Text;
					mainForm.myCAD1.GetSelectedShape().UserData.UserDataRecord[lvi.Index].Value = userdataEditForm.textValue.Text;
				}
				userdataEditForm.Dispose();
			
				//Reload
				UserDataForm_Load(sender,e);
			}
		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			foreach (ListViewItem lvi in listUserData.SelectedItems)
			{
				mainForm.myCAD1.GetSelectedShape().UserData.DeleteRecordByKey(lvi.Text);

				//Reload
				UserDataForm_Load(sender,e);
			}
		}

		private void btnInsert_Click(object sender, System.EventArgs e)
		{
			foreach (ListViewItem lvi in listUserData.SelectedItems)
			{
				UserDataEditForm userdataEditForm = new UserDataEditForm();
				userdataEditForm.ShowDialog();
				if (userdataEditForm.DialogResult == DialogResult.OK)
				{
					mainForm.myCAD1.GetSelectedShape().UserData.InsertKeyAndValue(userdataEditForm.textKey.Text,userdataEditForm.textValue.Text,lvi.Index,false);
				}
				userdataEditForm.Dispose();

				//Reload
				UserDataForm_Load(sender,e);
			}
		}
	}
}
